<?php
	
//------------------------------------------------------------------------
// This script is a part of ABC Mail Manager
//
// Version: 2.5
// Homepage: www.zakkis.ca
// Copyright (c) 2002-2003 Zakkis Technology, Inc.
// All rights reserved.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
// REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
// SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
// STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
// OF THE POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------
	
	/**
	* Class supporting folder list saving and retrieval.
	*
	*	Author: Maxim A. Perenesneko, 2002
	*/
	
	
	class FolderList
	{
		var $data = array();
		var $changed = false;
	
		function FolderList()
		{
			if( file_exists('data/folders.dat') && is_readable('data/folders.dat') )
			{
				$this->data = parse_ini_file('data/folders.dat');
				if( !$this->data )
					$this->data = array();
			}
		}
		
		function Save()
		{
			$lines = array();
			
			ksort( $this->data );
			
			foreach( $this->data as $name => $no )
				$lines[] = "$name=$no";
			$data = implode("\n", $lines);
			
			$fd = fopen( 'data/folders.dat', 'wb' );
			fwrite( $fd, $data );
			fclose( $fd );
			
			chmod( 'data/folders.dat', 0666 );
			
			$this->changed = false;
		}
		
		function HasFolder( $name )
		{
			return isset( $this->data[ $name ] );
		}
		
		function GetCount()
		{
			return count( $this->data );
		}
		
		function GetFirst()
		{
			foreach( $this->data as $key => $value )
				return $key;
		}
		
		function Add( $name )
		{
			if( $this->HasFolder( $name ) )
				return;
				
			$no = 1;
			while( in_array( $no, $this->data ) )
				$no++;
				
			$this->data[ $name ] = $no;
			$this->changed = true;
		}
		
		function Remove( $name )
		{
			if( !$this->HasFolder( $name ) )
				return false;
			
			$no = $this->data[ $name ];
			if( file_exists("data/list$no.dat") )
				unlink("data/list$no.dat");
						
			unset( $this->data[ $name ] );
			$this->changed = true;
		}
		
		function RenameFolder( $oldname, $newname )
		{
			if( !$this->HasFolder( $oldname ) )
				return false;
			if( $this->HasFolder( $newname ) )
				return false;
				
			$no = $this->data[ $oldname ];
			unset( $this->data[ $oldname ] );
			$this->data[ $newname ] = $no;
			
			$this->changed = true;
			
			return true;
		}
	}

?>